
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class AdminsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const admins = await db.admins.create(
            {
                id: data.id || undefined,
        
        full_name: data.full_name
        ||
        null
            ,
            
        gmail_address: data.gmail_address
        ||
        null
            ,
            
        access_level: data.access_level
        ||
        null
            ,
            
        department: data.department
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await admins.setUser( data.user || null, {
            transaction,
        });
        

        

        

        return admins;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const adminsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                full_name: item.full_name
            ||
            null
            ,
            
                gmail_address: item.gmail_address
            ||
            null
            ,
            
                access_level: item.access_level
            ||
            null
            ,
            
                department: item.department
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const admins = await db.admins.bulkCreate(adminsData, { transaction });

        // For each item created, replace relation files
        

        return admins;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const admins = await db.admins.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.full_name !== undefined) updatePayload.full_name = data.full_name;
        
        
        if (data.gmail_address !== undefined) updatePayload.gmail_address = data.gmail_address;
        
        
        if (data.access_level !== undefined) updatePayload.access_level = data.access_level;
        
        
        if (data.department !== undefined) updatePayload.department = data.department;
        
        
        updatePayload.updatedById = currentUser.id;

        await admins.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await admins.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        

        
        

        

        return admins;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const admins = await db.admins.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of admins) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of admins) {
                await record.destroy({transaction});
            }
        });


        return admins;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const admins = await db.admins.findByPk(id, options);

        await admins.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await admins.destroy({
            transaction
        });

        return admins;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const admins = await db.admins.findOne(
            { where },
            { transaction },
        );

        if (!admins) {
            return admins;
        }

        const output = admins.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        output.medicine_dispatches_approved_by_admin = await admins.getMedicine_dispatches_approved_by_admin({
            transaction
        });
        
        
        
        output.medical_camps_created_by_admin = await admins.getMedical_camps_created_by_admin({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await admins.getUser({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.full_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'admins',
                        'full_name',
                        filter.full_name,
                    ),
                };
            }
            
            if (filter.gmail_address) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'admins',
                        'gmail_address',
                        filter.gmail_address,
                    ),
                };
            }
            
            if (filter.department) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'admins',
                        'department',
                        filter.department,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.access_level) {
                where = {
                    ...where,
                access_level: filter.access_level,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.admins.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'admins',
                        'full_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.admins.findAll({
            attributes: [ 'id', 'full_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['full_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.full_name,
        }));
    }

    
};

